CREATE DEFINER=`root`@`%` PROCEDURE `getClassificators`(IN `_oid` INT)
	LANGUAGE SQL
	NOT DETERMINISTIC
	CONTAINS SQL
	SQL SECURITY DEFINER
	COMMENT ''
BEGIN
	DECLARE cid INT;
	DECLARE chs INT;
	DECLARE done INT DEFAULT FALSE;
	DECLARE c CURSOR FOR SELECT id FROM classificator WHERE classificator.oid = _oid AND pid = 0;
	DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;
	
	SET @@session.max_sp_recursion_depth=255;
	
	DROP TEMPORARY TABLE IF EXISTS nodes;
	CREATE TEMPORARY TABLE nodes (id INT, lvl INT, cnt INT);
	
	OPEN c;
	
	g: LOOP
		FETCH c INTO cid; 
		
		IF done THEN
      	LEAVE g;
    	END IF;
		
		SELECT COUNT(id) INTO chs FROM classificator WHERE pid = cid;
		INSERT INTO nodes(id, lvl, cnt) VALUES (cid, 0, chs);
		CALL getClassificator(cid, 0);

	END LOOP g;
	CLOSE c;
	
	SELECT nodes.id, code, name, lvl, cnt FROM nodes, classificator WHERE nodes.id = classificator.id;
END